package core

import (
	"github.com/louisevanderlith/husk"
)

type vehicleCalc func(result interface{}, obj Vehicle) error

func (f vehicleCalc) Calc(result interface{}, obj husk.Dataer) error {
	return f(result, obj.(Vehicle))
}

func Years() vehicleCalc {
	return func(result interface{}, obj Vehicle) error {
		lst := *(result.(*map[int]struct{}))

		lst[obj.Year] = struct{}{}

		result = &lst

		return nil
	}
}

func Manufacturers(year int) vehicleCalc {
	return func(result interface{}, obj Vehicle) error {
		lst := *(result.(*map[string]struct{}))

		if obj.Year == year {
			lst[obj.Series.Manufacturer] = struct{}{}
		}

		result = &lst

		return nil
	}
}

func Models(year int, manufacturer string) vehicleCalc {
	return func(result interface{}, obj Vehicle) error {
		lst := *(result.(*map[string]struct{}))

		if obj.Year == year && obj.Series.Manufacturer == manufacturer {
			lst[obj.Series.Model] = struct{}{}
		}

		result = &lst

		return nil
	}
}

func Trim(year int, manufacturer, model string) vehicleCalc {
	return func(result interface{}, obj Vehicle) error {
		lst := *(result.(*map[string]struct{}))

		if obj.Year == year && obj.Series.Manufacturer == manufacturer && obj.Series.Model == model {
			lst[obj.Trim] = struct{}{}
		}

		result = &lst

		return nil
	}
}
